"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "createQmlComponent", {
  enumerable: true,
  get: function get() {
    return _createQmlComponent.default;
  }
});
Object.defineProperty(exports, "createRawQmlComponent", {
  enumerable: true,
  get: function get() {
    return _createRawQmlComponent.default;
  }
});
exports.default = exports.render = void 0;

var _reactReconciler = _interopRequireDefault(require("react-reconciler"));

var _hostConfig = _interopRequireDefault(require("./hostConfig"));

var _createQmlComponent = _interopRequireDefault(require("./createQmlComponent"));

var _createRawQmlComponent = _interopRequireDefault(require("./createRawQmlComponent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReactReconcilerInst = (0, _reactReconciler.default)(_hostConfig.default);
var rootContainer;

var noop = function noop() {};

var render = function render(element, renderDom, callback) {
  // element: This is the react element for App component
  // renderDom: This is the host root element to which the rendered app will be attached.
  // callback: if specified will be called after render is done.
  var rootElement = renderDom || Qt.application;
  var isConcurrent = false; // disables concurrent rendering

  var hydrate = false; // not supported

  if (!rootContainer) {
    // Creates root fiber node.
    rootContainer = ReactReconcilerInst.createContainer(rootElement, isConcurrent, hydrate);
  } // Since there is no parent (this is the root fiber). We set parentComponent to null.


  var parentComponent = null;
  ReactReconcilerInst.injectIntoDevTools({
    bundleType: 1,
    // 0 for PROD, 1 for DEV
    version: '0.1.0',
    // version for your renderer
    rendererPackageName: 'qml-renderer' // package name

  });
  return ReactReconcilerInst.updateContainer(element, rootContainer, parentComponent, callback || noop); // Start reconcilation and render the result
};

exports.render = render;
var _default = {
  render: render,
  createQmlComponent: _createQmlComponent.default,
  createRawQmlComponent: _createRawQmlComponent.default
};
exports.default = _default;